library Act1;
{ Windows Installer custom action type 1 Delphi source sample
  by Ainars Skangals
  WWW  http://balder.prohosting.com/ainars
  Email ainarssk@email.com
  This sample can be compiled with Delphi 2 - 5
  See also sample .msi file
}
uses
  SysUtils,
  Windows;
//  Classes;
Const
    MSIRUNMODE_ADMIN           =  0; // admin mode install, else product install
    MSIRUNMODE_ADVERTISE       =  1; // installing advertisements, else installing or updating product
    MSIRUNMODE_MAINTENANCE     =  2; // modifying an existing installation, else new installation
    MSIRUNMODE_ROLLBACKENABLED =  3; // rollback is enabled
    MSIRUNMODE_LOGENABLED      =  4; // log file active, enabled prior to install session
    MSIRUNMODE_OPERATIONS      =  5; // spooling execute operations, else in determination phase
    MSIRUNMODE_REBOOTATEND     =  6; // reboot needed after successful installation (settable)
    MSIRUNMODE_REBOOTNOW       =  7; // reboot needed to continue installation (settable)
    MSIRUNMODE_CABINET         =  8; // installing files from cabinets and files using Media table
    MSIRUNMODE_SOURCESHORTNAMES=  9; // source LongFileNames suppressed via PID_MSISOURCE summary property
    MSIRUNMODE_TARGETSHORTNAMES= 10; // target LongFileNames suppressed via SHORTFILENAMES property
    MSIRUNMODE_RESERVED11      = 11; // future use
    MSIRUNMODE_WINDOWS9X       = 12; // operating systems is Windows9X, else Windows NT
    MSIRUNMODE_ZAWENABLED      = 13; // operating system supports demand installation
    MSIRUNMODE_RESERVED14      = 14; // future use
    MSIRUNMODE_RESERVED15      = 15; // future use
    MSIRUNMODE_SCHEDULED       = 16; // custom action call from install script execution
    MSIRUNMODE_ROLLBACK        = 17; // custom action call from rollback execution script
    MSIRUNMODE_COMMIT          = 18; // custom action call from commit execution script

// MSI function declarations
Function MsiGetProperty(
  hInstall:LongInt;       // installer handle
  szName,                 // property identifier, case-sensitive
  szValueBuf:PChar;       // buffer for returned property value
  var pchValueBuf:LongInt // in/out buffer character count
  ):Word; stdcall; external 'Msi.dll' name 'MsiGetPropertyA';
Function MsiSetProperty(
  hInstall:LongInt;     // installer handle
  szName,               // property identifier, case-sensitive
  szValue:PChar         // property value, NULL to undefine property
  ):Word; stdcall; external 'Msi.dll' name 'MsiSetPropertyA';
Function MsiGetMode(
  hInstall:LongInt;    // installer handle
  iRunMode:Word        // run mode
  ):boolean; stdcall; external 'msi.dll';

function MainProc(MSIHandle:LongInt):ShortInt; StdCall;
var
 F:textfile;
 i:integer;
 li,li1:longint;
 s:string;
 b:array[0..512] of char;
begin
 Result:=0; // succesful execution
 li1:=500;
 try
 if MsiGetProperty(msihandle,'PIDKEY',@b,li1)=0 then begin
    s:=Uppercase(StrPas(@b));
    if trim(s)='' then begin // if PIDKEY is set then it is installation
     li1:=500;
     if MsiGetProperty(msihandle,'REMOVE',@b,li1)=0 then  // test if REMOVE=ALL is set
      if uppercase(strpas(@b))<>'ALL' then begin
        // if not, then maintenance
        MsiSetProperty(msihandle,'CODEPROP','Test OK');
        // Your maintenance specific code here
        MessageBox(getdesktopwindow, 'Maintenance','Custom action', MB_SYSTEMMODAL or MB_OK);
      // if set then full uninstall
      end else begin
      // Your uninstallation specific code here
      MessageBox(getdesktopwindow, 'Remove','Custom action', MB_SYSTEMMODAL or MB_OK);
      end;
      end else begin
      MsiSetProperty(msihandle,'CODEPROP','Test OK');
      // Your installation specific code here
      MessageBox(getdesktopwindow, 'Install','Custom action', MB_SYSTEMMODAL or MB_OK);

      end;
 end;
 except
 end;
end;

exports
  MainProc index 1;
begin
end.
